#!/usr/bin/perl
use warnings;
use strict;
use Tk;
use Tk::JPEG;
use Tk::PNG;

my $file = shift || die "need a bmp, gif, jpg or png image as argument\n";

my $top  = Tk::MainWindow->new;

my $xy = $top->Label(-text => 'Use cursor keys (left, right, ...) also together with Shift and Control keys')->pack(-side => 'top',-padx=>2);

my $wc = 400;
my $can = $top->Scrolled('Canvas',
                 -height => $wc/2,
                 -width  => $wc,
                 -scrollbars => 'osoe',
                 -highlightthickness=>0,
                 -borderwidth =>0,
                 )->pack( -fill =>'both',-expand=>1);

my $realcan = $can->Subwidget('scrolled');

my $img = $top->Photo( -file => "$file" );

$can->createImage(0,0, -image => $img, -anchor => 'nw', -tags => ['IMG']);

my @bbox = $can->bbox('IMG');

$can->configure(-scrollregion => [@bbox] );

#$realcan->Tk::bind("<Motion>", [ \&print_xy, Ev('x'), Ev('y') ]);

my $wb = 100;
my $x = $wc/2 - $wb/2;
my $y = $wc/4 - $wb/2;
$can->createRectangle($x, $y, $x+$wb, $y+$wb, -tags => ['RECT'], -outline => 'red');

$top->bind('<Key-Right>', sub { 
  my @c = $can->coords('RECT');
  $can->coords('RECT', $c[0]+1, $c[1], $c[2], $c[3]) if ($c[0]+1 < $c[2]);
});

$top->bind('<Key-Left>', sub { 
  my @c = $can->coords('RECT');
  $can->coords('RECT', $c[0]-1, $c[1], $c[2], $c[3]) if ($c[0]-1 >= 0);
});


$top->bind('<Key-Down>', sub { 
  my @c = $can->coords('RECT');
  $can->coords('RECT', $c[0], $c[1]+1, $c[2], $c[3]) if ($c[1]+1 < $c[3]);
});

$top->bind('<Key-Up>', sub { 
  my @c = $can->coords('RECT');
  $can->coords('RECT', $c[0], $c[1]-1, $c[2], $c[3]) if ($c[1]-1 >= 0);
});

$top->bind('<Shift-Down>', sub { 
  my @c = $can->coords('RECT');
  my @i = $can->bbox('IMG');
  $can->coords('RECT', $c[0], $c[1], $c[2], $c[3]+1) if ($c[3]+1 <= $i[3]);
});

$top->bind('<Shift-Up>', sub { 
  my @c = $can->coords('RECT');
  $can->coords('RECT', $c[0], $c[1], $c[2], $c[3]-1) if ($c[3]-1 > $c[1]);
});

$top->bind('<Shift-Right>', sub { 
  my @c = $can->coords('RECT');
  $can->coords('RECT', $c[0], $c[1], $c[2]+1, $c[3]);
});

$top->bind('<Shift-Left>', sub { 
  my @c = $can->coords('RECT');
  $can->coords('RECT', $c[0], $c[1], $c[2]-1, $c[3]);
});

$top->bind('<Control-Right>', sub { 
  my @c = $can->coords('RECT');
  $can->coords('RECT', $c[0]+1, $c[1], $c[2]+1, $c[3]);
});

$top->bind('<Control-Left>', sub { 
  my @c = $can->coords('RECT');
  $can->coords('RECT', $c[0]-1, $c[1], $c[2]-1, $c[3]);
});
MainLoop();
